Bug 51078 - [PATCH] mod_fcgid spawned CGI Processes gets orphaned when Apache gets restarted/killed
Summary: [PATCH] mod_fcgid spawned CGI Processes gets orphaned when Apache gets restar...
Status: RESOLVED LATER
Alias: None
Product: Apache httpd-2
Classification: Unclassified
Component: mod_fcgid (show other bugs)
Version: 2.2.17
Hardware: PC Windows Server 2003
: P2 normal (vote)
Target Milestone: ---
Assignee: Apache HTTPD Bugs Mailing List
URL:
Keywords: MassUpdate, PatchAvailable
Depends on:
Blocks:
 
Reported: 2011-04-18 19:36 UTC by Thangaraj AntonyCrouse
Modified: 2018-11-07 21:09 UTC (History)
2 users (show)



Attachments
Patch to fix mod_fcgid spwaned CGI process orphaning when Apache is restarted/killed (7.82 KB, patch)
2011-04-18 19:36 UTC, Thangaraj AntonyCrouse
Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Thangaraj AntonyCrouse 2011-04-18 19:36:29 UTC
Created attachment 26897 [details]
Patch to fix mod_fcgid spwaned CGI process orphaning when Apache is restarted/killed

Problem:
mod_fcgid created CGI processes get orphaned during Apache shutdown or abrupt child process termination. 

Reproduction steps:
Allow Apache Child process to spwan few CGI process via mod_fcgid. Kill the Apache child process.

Root Cause:
Apache when run as windows service during shutdown/restart of service process (master/parent) will terminate child httpd process within 30 seconds (refer \server\mpm\winnt\mpm_winnt.c:master_main()  int timeout = 30000), therefore if Apache worker threads are too busy to react to Master's graceful exit signal within 30 seconds - mod_fcgid cleanup routines will not get invoked (refer \server\mpm\winnt\child.c: child_main() apr_pool_destroy(pchild); ) thereby orphaning all mod_fcgid spwaned CGI processes. 
  
Solution (implemented in patch):
Utilize Win32 JobObjects to clean up child processes automatically so that CGI processes are gauranteed to get killed during abnormal mod_fcgid/Apache termination. Created a new Fcgid configuration option called FcgidWin32PreventOrphans.
Comment 1 Steffen 2011-08-16 19:38:37 UTC
Attention to Bug report 50309, patch there addresses same issue.
Comment 2 Mario 2014-07-26 17:07:50 UTC
isn't that issues fixed with https://issues.apache.org/bugzilla/show_bug.cgi?id=50309 ?
Comment 3 William A. Rowe Jr. 2018-11-07 21:09:10 UTC
Please help us to refine our list of open and current defects; this is a mass update of old and inactive Bugzilla reports which reflect user error, already resolved defects, and still-existing defects in httpd.

As repeatedly announced, the Apache HTTP Server Project has discontinued all development and patch review of the 2.2.x series of releases. The final release 2.2.34 was published in July 2017, and no further evaluation of bug reports or security risks will be considered or published for 2.2.x releases. All reports older than 2.4.x have been updated to status RESOLVED/LATER; no further action is expected unless the report still applies to a current version of httpd.

If your report represented a question or confusion about how to use an httpd feature, an unexpected server behavior, problems building or installing httpd, or working with an external component (a third party module, browser etc.) we ask you to start by bringing your question to the User Support and Discussion mailing list, see [https://httpd.apache.org/lists.html#http-users] for details. Include a link to this Bugzilla report for completeness with your question.

If your report was clearly a defect in httpd or a feature request, we ask that you retest using a modern httpd release (2.4.33 or later) released in the past year. If it can be reproduced, please reopen this bug and change the Version field above to the httpd version you have reconfirmed with.

Your help in identifying defects or enhancements still applicable to the current httpd server software release is greatly appreciated.